#!/bin/sh
# $Id$

#       -----         -----         
#      /     \       /     \       /
#     /       \     /       \     /
#-----         -----         -----
#     \       /     \       /     \
#      \     /       \     /       \
#       -----         ----- detLFS  -
#      /     \       /     \       /
#     /       \     /       \     /
#-----         -----         -----
#http://www.dettus.net/detLFS

# The purpose of this script is to cross-compile packages
# Hopefully, the previous scripts are finished at this point

export DETLFSROOT=`pwd`
export TOOLSDIR=`pwd`/Tools
export DOWNLOADSDIR=`pwd`/Downloads
export DESTINATIONDIR=`pwd`/Destination
export SOURCESDIR=`pwd`/Sources



export DESTDIR=$DESTINATIONDIR
export PATH=$TOOLSDIR/bin:$PATH
export CROSS_COMPILE=$TOOLSDIR/bin/arm-linux-gnueabihf-

echo ">>> building BINUTILS"
(
	cd $SOURCESDIR/build/
	tar xvfz $DOWNLOADSDIR/binutils-2.26.1.tar.gz	
	cd binutils-2.26.1
	export CROSS_COMPILE=$TOOLSDIR/bin/arm-linux-gnueabihf-
	mkdir build-cross ; cd build-cross
	../configure --target=arm-linux-gnueabihf --host=arm-linux-gnueabihf --prefix=/usr --with-sysroot --disable-nls --disable-werror
	make -j 4
	make install
)

echo ">>> installing glibc (for real)"
(
	cd $SOURCESSDIR/build/
	tar xvfJ $DOWNLOADSDIR/glibc-2.23.tar.xz
	cd glibc-2.23
	mkdir build-cross ; cd build-cross
	../configure --host=arm-linux-gnueabihf --prefix=/ --with-headers=$DESTINATIONDIR/usr/include
	make -j 4 cross-compiling=yes
	make -j 4 cross-compiling=yes  install
	make install
)

echo ">>> installing glibc (again)"
(
	cd $SOURCESDIR/build/
	tar xvfJ $DOWNLOADSDIR/glibc-2.23.tar.xz
	cd glibc-2.23
	mkdir build2-cross ; cd build2-cross
	../configure --host=arm-linux-gnueabihf --prefix=/arm-linux-gnueabihf/ --with-headers=$DESTINATIONDIR/usr/include
	make -j 4 cross-compiling=yes
	make -j 4 cross-compiling=yes  install
	make install
)


